freeslot("SKINCOLOR_FIGHTER", "SKINCOLOR_CFDASH", "SKINCOLOR_CFFADE", "SKINCOLOR_ABSOLUTE",
"sfx_clfsw", "sfx_clfdn",
"MT_CFHEAD", "S_CFHEAD_I0", "S_CFHEAD_I1", "S_CFHEAD_I2", "S_CFHEAD_IR", "S_CFHEAD")

sfxinfo[sfx_clfsw].caption = "/"
sfxinfo[sfx_clfdn].caption = "/"

skincolors[SKINCOLOR_FIGHTER] = {
	name = "Fighter",
	ramp = {0,0,1,3,5,7,9,11,13,15,17,19,22,25,28,31},
	invcolor = SKINCOLOR_CFDASH,
	invshade = 3, 
	chatcolor = V_GRAYMAP,
	accessible = true
}

skincolors[SKINCOLOR_CFDASH] = {
	name = "Boost Mode",
	ramp = {0,0,1,3,5,7,9,11,13,15,17,19,22,25,28,31},
	invcolor = SKINCOLOR_FIGHTER,
	invshade = 7, 
	chatcolor = V_REDMAP,
	accessible = true
}

skincolors[SKINCOLOR_CFFADE] = {
    name = "Green Light",
    ramp = {112,112,112,112,112,112,112,112,112,112,112,112,112,112,112,112},
    accessible = false
}

skincolors[SKINCOLOR_ABSOLUTE] = {
	name = "Absolute",
	ramp = {0,80,81,82,83,72,64,65,66,67,68,69,70,71,46,47},
	accessible = false
}

local colorRamps = {
    [0] = {0,0,1,3,5,7,9,11,13,15,17,19,22,25,28,31},
    [1] = {0,2,4,6,8,10,12,14,16,18,20,22,24,26,29,31}
}
local dashRamps = {
    [0] = {0,0,208,216,50,32,34,35,35,37,40,40,42,43,44,45},
    [1] = {0,208,49,51,32,34,37,38,40,41,42,43,43,44,46,47}
}

local absRamps = {
    [0] = {0,80,81,82,83,72,64,65,66,67,68,69,66,67,68,69},
    [1] = {83,72,64,65,66,67,68,69,70,71,46,47,70,71,46,47}
}

addHook("ThinkFrame", function()
	skincolors[SKINCOLOR_FIGHTER].ramp = colorRamps[leveltime%2]
    skincolors[SKINCOLOR_CFDASH].ramp = dashRamps[leveltime%2]
    skincolors[SKINCOLOR_ABSOLUTE].ramp = absRamps[leveltime%2]
end)

rawset(_G, "CloneFighter", {
    version = {3,0,0},
    skinList = {},
    nameSkin = {}
})

addHook("MapChange", do
    CloneFighter.skinList = {}
    CloneFighter.nameSkin = {}
    for skin in skins.iterate do
        if skin.name == "clonefighter" then continue end
        table.insert(CloneFighter.skinList, #skin)
        CloneFighter.nameSkin[skin.name] = #CloneFighter.skinList
    end
end)

addHook("NetVars", function(net)
    CloneFighter = net($)
    CloneFighter.skinList = net($)
    CloneFighter.nameSkin = net($)
end)

-- So no head?
local function A_CFHead(mo, var1)
    mo.colorized = true
    for i = 0, 1 do
        local vwre = P_SpawnMobjFromMobj(mo, 0,0,-8*mo.scale * max(-P_MobjFlip(mo)*2, 0), MT_VWREF+i)
        vwre.flags = $|MF_NOCLIP
        vwre.eflags = mo.eflags
        vwre.scale = mo.scale/3
        vwre.fuse = 7
        P_SetObjectMomZ(vwre, 12*FRACUNIT)
    end
end

states[S_CFHEAD_I0] = {SPR_NULL, A,                                  1,  A_Repeat, 1,S_CFHEAD_I1, S_CFHEAD_I1} -- Initiate

states[S_CFHEAD_I1] = {SPR_PLAY, SPR2_LIFE|FF_FULLBRIGHT|FF_TRANS20, 1,  A_CFHead, 0,0,           S_CFHEAD_I2} -- Loop
states[S_CFHEAD_I2] = {SPR_NULL, A,                                  1,  nil,      0,0,           S_CFHEAD_IR}
states[S_CFHEAD_IR] = {SPR_NULL, A,                                  0,  A_Repeat, 5,S_CFHEAD_I1, S_CFHEAD   }

states[S_CFHEAD]    = {SPR_PLAY, SPR2_LIFE|FF_FULLBRIGHT|FF_TRANS20, -1, nil,      0,0,           S_CFHEAD   } -- Main

mobjinfo[MT_CFHEAD] = {
    doomednum = -1,
    spawnstate = S_CFHEAD_I0,
    spawnhealth = 1,
    reactiontime = 8,
    speed = 0,
    radius = 8*FRACUNIT,
    height = 16*FRACUNIT,
    dispoffset = 0,
    mass = 1000,
    flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP
}

addHook("MobjSpawn", function(mo)
    mo.startz = mo.z
end, MT_CFHEAD)

addHook("MobjThinker", function(mo)
    mo.z = mo.startz + P_MobjFlip(mo)*3*cos(ease.linear(leveltime*FRACUNIT/195, 0, 359)*ANG1)
end, MT_CFHEAD)
