local MoveHUDSkins = {
	skip = true,
	windows = true,
	kiryu = true
}
hud.add(function(v, player)
    if not player.mo or not player.mo.valid or player.skin != #skins["clonefighter"] or not player.CF or not CloneFighter or not CloneFighter.skinList then return end
    
    local x,y,f = 16,176,V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS|V_PERPLAYER
    -- Lives
    if hud.enabled("lives") and (player.powers[pw_carry] != CR_NIGHTS) then
        x,y,f = hudinfo[HUD_LIVES].x, hudinfo[HUD_LIVES].y-18, hudinfo[HUD_LIVES].f|V_HUDTRANS|V_PERPLAYER
		if MoveHUDSkins[player.mo.skin] then
			x,y = $1+60, $2+18
		end
        if player.mo.skin != "kiryu" then
			local ptc = v.getSprite2Patch(player.mo.skin, SPR2_XTRA, player.powers[pw_super] and true or false, A, 1)
			v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, hudinfo[HUD_LIVES].y*FRACUNIT, FRACUNIT/2, ptc,
					hudinfo[HUD_LIVES].f|V_HUDTRANS|V_PERPLAYER, v.getColormap(TC_RAINBOW, player.mo.color))
			if player.CF.shifting then
				local r = v.RandomRange(1, 4)
				local stc = v.cachePatch("CFSTC"..tostring(r))
				v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, hudinfo[HUD_LIVES].y*FRACUNIT, FRACUNIT/2, stc, hudinfo[HUD_LIVES].f|V_HUDTRANS|V_PERPLAYER)
			end
		end
    end
    
    -- The small indicators for next and prev char and/or Last Resort
    if player.CF.skin then
        if G_RingSlingerGametype() then
            local vmap = CF_ReadySwitch(player, player.CF.skin) and V_YELLOWMAP or V_GRAYMAP
            v.drawString(x, y+8, "FRN: SWITCH", vmap|f, "thin")
        else
            for i = -1, 1, 2 do
                local skin = player.CF.skin+i
                if skin > #CloneFighter.skinList then
                    skin = 1
                elseif skin < 1 then
                    skin = #CloneFighter.skinList
                end
                local ptc = v.getSprite2Patch(CloneFighter.skinList[skin], SPR2_XTRA, player.powers[pw_super] and true or false, A, 1)
                local cmap = v.getColormap(TC_RAINBOW, player.mo.color)
                v.drawScaled(i<1 and (x+6)*FRACUNIT or (x+2)*FRACUNIT, i<1 and (y+8)*FRACUNIT or y*FRACUNIT, FRACUNIT/4, ptc, f, cmap)
                if not CF_ReadySwitch(player, skin) then
                    local r = v.RandomRange(1, 4)
                    local stc = v.cachePatch("CFSTC"..tostring(r))
                    v.drawScaled(i<1 and (x+6)*FRACUNIT or (x+2)*FRACUNIT, i<1 and (y+8)*FRACUNIT or y*FRACUNIT, FRACUNIT/4, stc, f)
                end
                
                local str = i<1 and "\028" or "\029"
                local vmap = CF_ReadySwitch(player, skin) and V_YELLOWMAP or V_GRAYMAP
                v.drawString(i<1 and x+8 or x+10, i<1 and y+8 or y, str, vmap|f, i<1 and "right" or "left")
            end
        end
    end
    
    -- Skin Menu
    if player.CF.menuUp then
        if not splitscreen then -- Much more complicaated layout for single player.
			-- Draw before fading for cool effect
			local clonepatch = v.getSprite2Patch("clonefighter", SPR2_CNT3, leveltime%6 / 3)
			v.draw(160, 165, clonepatch, 0, v.getColormap("clonefighter", SKINCOLOR_CFFADE))
			
            v.fadeScreen(0xFA00, 8)
			
			-- Make the glow... glow
			local projpatch = v.getSpritePatch(SPR_PROJ, B + ((leveltime+3)%6 / 3))
			v.draw(160, 162, projpatch, 0, v.getColormap(TC_RAINBOW, SKINCOLOR_CFFADE))
            
            v.drawNameTag(160, 8, "SHAPE SHIFT", V_CENTERNAMETAG|V_SNAPTOTOP, player.skincolor, skincolors[player.skincolor].invcolor)
            
            -- Shortcuts
            v.drawString(160, 32, "Quick Shift Shortcuts:", V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin-center")
            for i = 1, 7 do
                local chr = CloneFighter.nameSkin[player.CF.shortcuts[i]] and player.CF.shortcuts[i] or "clonefighter"
                local ptc = v.getSprite2Patch(chr,
                        SPR2_LIFE, player.powers[pw_super] and true or false, A, 1)
                local cmap = v.getColormap(TC_RAINBOW, player.mo.color)
                if not ((player.CF.shortcuts[i] != nil)
                and CF_ReadySwitch(player, CloneFighter.nameSkin[player.CF.shortcuts[i]])) then
                    cmap = v.getColormap(TC_BLINK, SKINCOLOR_BLACK)
                end
                v.drawScaled((160 + ((i-4)*20))*FRACUNIT, 56*FRACUNIT, skins[chr].highresscale, ptc, V_SNAPTOTOP, cmap)
                if chr == "clonefighter" then
                    v.drawString(160 + ((i-4)*20), 49, '?', V_SNAPTOTOP, "center")
                end
                local map = (CloneFighter.nameSkin[player.CF.shortcuts[i]] == player.CF.menuSelect) and V_YELLOWMAP or 0
                v.drawString(160 + ((i-4)*20), 40, i, V_SNAPTOTOP|map, "center")
            end
            
            -- Selection
            local order = {-2,2,-1,1,0}
            for _, i in ipairs(order) do
                local skin = player.CF.menuSelect+i
                if skin > #CloneFighter.skinList then
                    skin = $-#CloneFighter.skinList
                elseif skin < 1 then
                    skin = $+#CloneFighter.skinList
                end
                local ptc, flp = v.getSprite2Patch(CloneFighter.skinList[skin], SPR2_STND, player.powers[pw_super] and true or false, A, 8)
                local cmap = v.getColormap(TC_RAINBOW, player.mo.color)
                if not (R_SkinUsable(player, CloneFighter.skinList[skin])) then
                    cmap = v.getColormap(TC_BLINK, SKINCOLOR_BLACK)
                end
                v.drawScaled((160 + (i*45))*FRACUNIT, (140-(abs(i)*6))*FRACUNIT, FixedMul(FRACUNIT - (abs(i)*FRACUNIT/6), skins[CloneFighter.skinList[skin]].highresscale),
                        ptc, (abs(i)*3 << V_ALPHASHIFT)|(flp and V_FLIP or 0), cmap)
            end
            
            -- Name
            local name = skins[CloneFighter.skinList[player.CF.menuSelect]].realname
            if not (R_SkinUsable(player, CloneFighter.skinList[player.CF.menuSelect])) then
                name = "???????"
            end
            v.drawString(160, 144, name, V_ALLOWLOWERCASE|V_YELLOWMAP, "center")
            
            local space = (leveltime%10 > 4) and 6 or 8
            v.drawString(160-((v.stringWidth(name, V_ALLOWLOWERCASE)/2)+space), 144, "\028", V_ALLOWLOWERCASE|V_YELLOWMAP, "right")
            v.drawString(160+((v.stringWidth(name, V_ALLOWLOWERCASE)/2)+space), 144, "\029", V_ALLOWLOWERCASE|V_YELLOWMAP, "left")
            
            local zt = 0
            -- (You!)
            if player.CF.menuSelect == CloneFighter.nameSkin[player.mo.skin] then
                v.drawString(160, 152, "(You!)", V_GRAYMAP|V_ALLOWLOWERCASE, "thin-center")
                zt = 8
            end
            
            -- (Cannot Shape-Shift during a zoom tube.)
            if player.powers[pw_carry] == CR_ZOOMTUBE then
                v.drawString(160, 152+zt, "(Cannot Shape Shift during a zoom tube.)", V_REDMAP|V_ALLOWLOWERCASE, "thin-center")
            end
            
            v.drawString(160, 182, "STRAFE L/R: SELECT CHAR // JUMP: CONFIRM", V_SNAPTOBOTTOM|V_YELLOWMAP, "thin-center")
            v.drawString(160, 190, "WEAPON NUM: SET SHORTCUT // FIRE NORMAL: EXIT", V_SNAPTOBOTTOM|V_YELLOWMAP, "thin-center")
        
        else -- Splitscreen moment, campact HUD
            local sy = 60
            if secondarydisplayplayer == player then
                sy = $+100
            end
            
            -- Shortcuts
            v.drawString(200, sy-58, "Shortcuts:", V_ALLOWLOWERCASE, "thin-center")
            for i = 1, 7 do
                local chr = CloneFighter.nameSkin[player.CF.shortcuts[i]] and player.CF.shortcuts[i] or "clonefighter"
                local ptc = v.getSprite2Patch(chr,
                        SPR2_LIFE, player.powers[pw_super] and true or false, A, 1)
                local cmap = v.getColormap(TC_RAINBOW, player.mo.color)
                if not ((player.CF.shortcuts[i] != nil)
                and CF_ReadySwitch(player, CloneFighter.nameSkin[player.CF.shortcuts[i]])) then
                    cmap = v.getColormap(TC_BLINK, SKINCOLOR_BLACK)
                end
                v.drawScaled((200 + ((i-4)*16))*FRACUNIT, (sy-37)*FRACUNIT, skins[chr].highresscale, ptc, 0, cmap)
                if chr == "clonefighter" then
                    v.drawString(200 + ((i-4)*16), (sy-44), '?', 0, "center")
                end
                local map = (CloneFighter.nameSkin[player.CF.shortcuts[i]] == player.CF.menuSelect) and V_YELLOWMAP or 0
                v.drawString(200 + ((i-4)*16), sy-51, i, map, "center")
            end
            
            -- Selection
            local order = {-2,2,-1,1,0}
            for _, i in ipairs(order) do
                local skin = player.CF.menuSelect+i
                if skin > #CloneFighter.skinList then
                    skin = $-#CloneFighter.skinList
                elseif skin < 1 then
                    skin = $+#CloneFighter.skinList
                end
                local ptc, flp = v.getSprite2Patch(CloneFighter.skinList[skin], SPR2_STND, player.powers[pw_super] and true or false, A, 8)
                local cmap = v.getColormap(TC_RAINBOW, player.mo.color)
                if not (R_SkinUsable(player, CloneFighter.skinList[skin])) then
                    cmap = v.getColormap(TC_BLINK, SKINCOLOR_BLACK)
                end
                v.drawScaled((160 + (i*20))*FRACUNIT, (sy-(abs(i)*3))*FRACUNIT, FixedMul(FRACUNIT - (abs(i)*FRACUNIT/6), skins[CloneFighter.skinList[skin]].highresscale/2),
                        ptc, (abs(i)*3 << V_ALPHASHIFT)|(flp and V_FLIP or 0), cmap)
            end
            
            -- Name
            local name = skins[CloneFighter.skinList[player.CF.menuSelect]].realname
            if not (R_SkinUsable(player, CloneFighter.skinList[player.CF.menuSelect])) then
                name = "???????"
            end
            v.drawString(160, sy+4, name, V_ALLOWLOWERCASE|V_YELLOWMAP, "center")
            
            local space = (leveltime%10 > 4) and 6 or 8
            v.drawString(160-((v.stringWidth(name, V_ALLOWLOWERCASE)/2)+space), sy+4, "\028", V_ALLOWLOWERCASE|V_YELLOWMAP, "right")
            v.drawString(160+((v.stringWidth(name, V_ALLOWLOWERCASE)/2)+space), sy+4, "\029", V_ALLOWLOWERCASE|V_YELLOWMAP, "left")
            
            -- (You!)
            local zt = 0
            if player.CF.menuSelect == CloneFighter.nameSkin[player.mo.skin] then
                v.drawString(160, sy+12, "(You!)", V_GRAYMAP|V_ALLOWLOWERCASE, "thin-center")
                zt = 8
            end
            
            -- (Cannot Shape-Shift during a zoom tube.)
            if player.powers[pw_carry] == CR_ZOOMTUBE then
                v.drawString(160, sy+12+zt, "(Cannot Shape Shift during a zoom tube.)", V_REDMAP|V_ALLOWLOWERCASE, "thin-center")
            end
            
            v.drawString(160, sy+33, "L/R:SEL | J:CNF | W#:SHRT | FN:EXIT", V_YELLOWMAP, "thin-center")
        end
    end
end)