-- I/O stuff begins here - base written by LJ Sonic, uploaded by Sz_ as a reusable add-on with permission
local file
local cfTemp = {}

COM_AddCommand("updateCFthings", function(player, arg, ...)
    if arg != "\x7F\x7F\x7F" then
        CONS_Printf(player, "Hey.\nWanna see my head come off?")
        return
    end
    
    cfTemp = {...}
    player.cfTempSkin = cfTemp[1] and CloneFighter.nameSkin[cfTemp[1]] or 1
    player.cfTempShort = {}
    for i = 1, 7
        player.cfTempShort[i] = cfTemp[i+1] or "sonic"
    end
end)

local function saveConfig(player, configname)
	-- Open the file ("w" means we will write data to it)
	file = io.openlocal(configname, "w")
    
	if file and player.CF then
		file:write(skins[CloneFighter.skinList[player.CF.skin]].name, "\n")
        for _, i in ipairs(player.CF.shortcuts) do
            file:write(i, "\n")
        end

		file:close() -- We're done, close the file now
	end
end

local function loadConfig(player, configname)
	-- Open the file ("r" means we will read data from it)
	file = io.openlocal(configname, "r")
    
	if file then
		local args = ""
        for i in file:lines() do
            args = $.." "..i
        end
		
        COM_BufInsertText(player, "updateCFthings \x7F\x7F\x7F"..args)
	end
end

addHook("PlayerSpawn", function(player)
    if player != consoleplayer then return end
    loadConfig(player, "client/cfData.dat")
end)

addHook("MobjDeath", function(mo) local player = mo.player
    if (player != consoleplayer) or not player.CF then return end
    saveConfig(player, "client/cfData.dat")
end, MT_PLAYER)

addHook("MapChange", do for player in players.iterate do
    if (player != consoleplayer) or not player.CF then continue end
    saveConfig(player, "client/cfData.dat")
    return
end; end)

addHook("PlayerQuit", function(player)
    if (player != consoleplayer) or not player.CF then return end
	saveConfig(player, "client/cfData.dat")
end)

addHook("GameQuit", do for player in players.iterate do
    if (player != consoleplayer) or not player.valid or not player.CF then continue end
	saveConfig(player, "client/cfData.dat")
    return
end; end)