local function CF_ReadySwitch(player, skin)
    if (CloneFighter.skinList[skin] != nil)
	and R_SkinUsable(player, CloneFighter.skinList[skin])
	and not (player.pflags & (PF_SPINNING|PF_STARTDASH))
	and not player.climbing
    and not P_PlayerInPain(player)
    and not player.CF.shifting
		return true
	end
	return false
end
rawset(_G, "CF_ReadySwitch", CF_ReadySwitch)
local function CF_ReadySwitchNS(player, skin)
    if (CloneFighter.skinList[skin] != nil)
	and R_SkinUsable(player, CloneFighter.skinList[skin])
	and not (player.pflags & (PF_SPINNING|PF_STARTDASH))
	and not player.climbing
    and not P_PlayerInPain(player)
	and not player.gemmasmash -- Terra-Riser?
		return true
	end
	return false
end
rawset(_G, "CF_ReadySwitchNS", CF_ReadySwitchNS)

-- Port of SetSkin from source code; except player.skin is not set. Also includes additional handling post-Shape Shift. VERY spaget ik.
local function CF_ShiftSkin(player, skinnum)
	local skin = skins[skinnum];
    if player.mo.skin == skin.name then S_StartSound(nil, sfx_cdfm39, player); return end

	player.camerascale = skin.camerascale;
	player.shieldscale = skin.shieldscale;

	player.charability = skin.ability;
	player.charability2 = skin.ability2;

	player.charflags = skin.flags|SF_MACHINE;

	player.thokitem = skin.thokitem < 0 and mobjinfo[MT_PLAYER].painchance or skin.thokitem;
	player.spinitem = skin.spinitem < 0 and mobjinfo[MT_PLAYER].damage or skin.spinitem;
	player.revitem = skin.revitem < 0 and mobjinfo[MT_PLAYER].raisestate or skin.revitem;
	player.followitem = skin.followitem;

	if (((player.powers[pw_shield] & SH_NOSTACK) == SH_PINK) and (player.revitem == MT_LHRT or player.spinitem == MT_LHRT or player.thokitem == MT_LHRT)) // Healers can't keep their buff.
		then player.powers[pw_shield] = $ & SH_STACK end

	player.actionspd = skin.actionspd;
	player.mindash = skin.mindash;
	player.maxdash = skin.maxdash;

	player.normalspeed = skin.normalspeed;
	player.runspeed = skin.runspeed;
	player.thrustfactor = skin.thrustfactor;
	player.accelstart = skin.accelstart;
	player.acceleration = skin.acceleration;

	player.jumpfactor = skin.jumpfactor;

	player.height = skin.height;
	player.spinheight = skin.spinheight;

	if (player.followmobj)
	then
		P_RemoveMobj(player.followmobj);
	end

	if (player.mo)
	then
		local radius = FixedMul(skin.radius, player.mo.scale);
		if ((player.powers[pw_carry] == CR_NIGHTSMODE) and (skin.sprites[SPR2_NFLY].numframes == 0)) // If you don't have a sprite for flying horizontally, use the default NiGHTS skin.
		then
			skin = skins[0];
			player.followitem = skin.followitem;
		end
		player.mo.skin = skin.name;
		P_SetScale(player.mo, player.mo.scale);
		player.mo.radius = radius;

		player.mo.state = $ // Prevent visual errors when switching between skins with differing number of frames
	end
    
    if not P_IsObjectOnGround(player.mo) then
        player.pflags = ($|PF_THOKKED) & ~PF_JUMPED
        player.mo.state = S_PLAY_FALL
    end
    
    player.CF.menuSelect = CloneFighter.nameSkin[skin.name] or 6
end
------------------------------------
-- -- --   MAIN BEHAVIOUR   -- -- --
------------------------------------

-- input spaget
COM_AddCommand("cf_getkeys", function(player, pass, ind, int)
    if pass != "\x5F\x5A\x5F" then
        CONS_Printf(player, "Access denied.")
    end
    
    if ind == "move" then
        player.CFsel = tonumber(int)
    elseif ind == "wep" then
        player.CFshort = tonumber(int)
    end
end)

addHook("KeyDown", function(key)
    -- L/R for select
    local aa, ab = input.gameControlToKeyNum(GC_STRAFELEFT)
    local ac, ad = input.gameControlToKeyNum(GC_STRAFERIGHT)
    local ba, bb = input.gameControl2ToKeyNum(GC_STRAFELEFT)
    local bc, bd = input.gameControl2ToKeyNum(GC_STRAFERIGHT)
    
    if key.num == aa or key.num == ab then
        COM_BufInsertText(consoleplayer, "cf_getkeys \x5F\x5A\x5F move -1")
    elseif key.num == ac or key.num == ad then
        COM_BufInsertText(consoleplayer, "cf_getkeys \x5F\x5A\x5F move 1")
    end
    if key.num == ba or key.num == bb then
        COM_BufInsertText(secondarydisplayplayer, "cf_getkeys \x5F\x5A\x5F move -1")
    elseif key.num == bc or key.num == bd then
        COM_BufInsertText(secondarydisplayplayer, "cf_getkeys \x5F\x5A\x5F move 1")
    end
    
    if key.repeated then return end
    -- Weapon slots are shortcuts
    for i = GC_WEPSLOT1, GC_WEPSLOT7 do
        local aa, ab = input.gameControlToKeyNum(i)
        local ba, bb = input.gameControl2ToKeyNum(i)
        if key.num == aa or key.num == ab then
            local wp = i-GC_WEPSLOT1+1
            COM_BufInsertText(consoleplayer, "cf_getkeys \x5F\x5A\x5F wep "..tostring(wp))
        end
        if key.num == ba or key.num == bb then
            local wp = i-GC_WEPSLOT1+1
            COM_BufInsertText(secondarydisplayplayer, "cf_getkeys \x5F\x5A\x5F wep "..tostring(wp))
        end
    end
end)

addHook("PlayerSpawn", function(player)
    if not player.mo or not player.mo.valid or (player.skin != #skins["clonefighter"]) then return end
    
    local si = player.CF and player.CF.signUsed
    player.CF = {
        active = true,
        menuUp = false,
        menuSelect = 6,
        skin = player.cfTempSkin or 6,
        shortcuts = player.cfTempShort or {"sonic", "tails", "knuckles", "amy", "fang", "metalsonic", "sonic"},
        
        -- Used for the sign
        signUsed = si or {},
        
        shifting = 0,
        shiftSkin = 6
    }
	if leveltime < 2 then player.CF.signUsed = {} end
end)

-- of course
local function inTable(t, a)
    local r = {}
    for i, v in pairs(t) do
        if v == a then
            table.insert(r, i)
        end
    end
    return r[1] and r or false
end

addHook("PlayerThink", function(player)
    if not player.mo or not player.mo.valid or player.playerstate != PST_LIVE or (player.skin != #skins["clonefighter"]) then return end
    
    local si = player.CF and player.CF.signUsed
    player.CF = $ or { -- In case of a skin switch
        active = true,
        menuUp = false,
        menuSelect = 6,
        skin = player.cfTempSkin or 6,
        shortcuts = player.cfTempShort or {"sonic", "tails", "knuckles", "amy", "fang", "metalsonic", "sonic"},
        
        -- Used for the sign
        signUsed = si or {},
        
        shifting = 0,
        shiftSkin = 6
    }
    player.CF.active = true
    if leveltime>=3 then player.cfTempSkin = player.CF.skin end
    
    if player.mo.skin == "clonefighter" then
        local dest
        if player.cfTempSkin and R_SkinUsable(player, CloneFighter.skinList[player.cfTempSkin]) then
            dest = CloneFighter.skinList[player.cfTempSkin]
        else dest = R_SkinUsable(player, "metalsonic") and "metalsonic" or "sonic" end
        CF_ShiftSkin(player, #skins[dest])
    end
    player.CF.skin = CloneFighter.nameSkin[player.mo.skin]
    if not inTable(player.CF.signUsed, player.mo.skin) then
        table.insert(player.CF.signUsed, player.mo.skin)
    end
    
    -- Shape Shift method 1: menu
    player.CF.menuUp = $ or false
    if player.cmd.buttons & BT_FIRENORMAL and not G_RingSlingerGametype() then
        if not player.CFmenu then
            if (player.powers[pw_underwater] and player.powers[pw_underwater] <= 11*TICRATE)
            or player.powers[pw_spacetime]
            or P_PlayerInPain(player)
            or (player.exiting and player.exiting < 99) then
                S_StartSoundAtVolume(nil, sfx_adderr, 127, player)
            else
                player.CF.menuUp = not $
                
                if player.CF.menuUp then
                    S_StartSound(nil, sfx_kc65, player)
                else
                    player.cfTempShort = player.CF.shortcuts
                    S_StartSound(nil, sfx_s3k52, player)
                end
            end
        end
        player.CFmenu = true
    else player.CFmenu = false end
    
	player.CFconf = $ or 0
    if player.cmd.buttons & BT_JUMP then
        player.CFconf = ($<5) and $+1 or 5
    else player.CFconf = 0 end
    
    if player.CF.menuUp then -- Disabled in ringslinger, leaving only the Last Resort shift
        if (player.powers[pw_underwater] and player.powers[pw_underwater] <= 11*TICRATE)
        or player.powers[pw_spacetime]
        or (player.exiting and player.exiting < 99)
        or G_RingSlingerGametype() then -- May seem redundant, but ringslinger can be turned on at any point by admins
            player.CF.menuUp = false
        end
        
        player.pflags = $|PF_FULLSTASIS
        player.powers[pw_flashing] = ($ > TICRATE/2) and $ or TICRATE/2
        
        if player.CFsel then
            player.CF.menuSelect = $+player.CFsel
            if player.CF.menuSelect > #CloneFighter.skinList then
                player.CF.menuSelect = 1
            elseif player.CF.menuSelect < 1 then
                player.CF.menuSelect = #CloneFighter.skinList
            end
            S_StartSound(nil, sfx_menu1, player)
        end
        
        if player.CFconf == 1 then
            -- Confirm choice?
            if (CloneFighter.skinList[player.CF.menuSelect] != nil) and CF_ReadySwitch(player, player.CF.menuSelect) then -- Nice
                if player.mo.skin == skins[CloneFighter.skinList[player.CF.menuSelect]].name then -- Oh you chose your skin. Uh...
                    S_StartSound(nil, sfx_cdfm39, player) -- N o
                else
                    player.CF.shifting = 1
                    player.CF.shiftSkin = player.CF.menuSelect
                end
                player.CF.menuUp = false
            else -- Bummer, unavailable skin.
                S_StartSound(nil, sfx_adderr, player)
            end
        end
        
    elseif not G_RingSlingerGametype()
        -- Shape Shift method 2: Cycle Shift (old method)
        if player.cmd.buttons & BT_WEAPONNEXT then -- Disabled in ringslinger, leaving only the Last Resort shift
            if not player.CFnext then
                local skinto = player.CF.skin+1
                if skinto > #CloneFighter.skinList then
                    skinto = 1
                end
                if (CloneFighter.skinList[skinto] != nil) and CF_ReadySwitch(player, skinto) then
                    player.CF.shifting = 1
                    player.CF.shiftSkin = skinto
                else
                    S_StartSoundAtVolume(nil, sfx_adderr, 127, player)
                end
            end
            player.CFnext = true
        else player.CFnext = false end
        if player.cmd.buttons & BT_WEAPONPREV then
            if not player.CFprev then
                local skinto = player.CF.skin-1
                if skinto < 1 then
                    skinto = #CloneFighter.skinList
                end
                if (CloneFighter.skinList[skinto] != nil) and CF_ReadySwitch(player, skinto) then
                    player.CF.shifting = 1
                    player.CF.shiftSkin = skinto
                else
                    S_StartSoundAtVolume(nil, sfx_adderr, 127, player)
                end
            end
            player.CFprev = true
        else player.CFprev = false end
        
    else
        -- Shape Shift method 4!: Last Resort (random!!!)
        if player.cmd.buttons & BT_FIRENORMAL then
            if not player.CFrand then
                local skinto = player.CF.skin
                while skinto == player.CF.skin do skinto = P_RandomRange(1, #CloneFighter.skinList) end -- Guarantee different character
                if (CloneFighter.skinList[skinto] != nil) and CF_ReadySwitch(player, skinto) then
                    player.CF.shifting = 1
                    player.CF.shiftSkin = skinto
                else
                    S_StartSoundAtVolume(nil, sfx_adderr, 127, player)
                end
            end
            player.CFrand = true
        else player.CFrand = false end
    end
    
    -- Shape Shift method 3: Quick Shift (shortcuts)
    if player.CFshort and not G_RingSlingerGametype() then -- Disabled in ringslinger, leaving only the Last Resort shift
        if player.CF.menuUp then
            if (CloneFighter.skinList[player.CF.menuSelect] != nil) and CF_ReadySwitch(player, player.CF.menuSelect) then
                player.CF.shortcuts[player.CFshort] = skins[CloneFighter.skinList[player.CF.menuSelect]].name
                S_StartSound(nil, sfx_strpst, player)
            else
                S_StartSound(nil, sfx_adderr, player)
            end
        else
            local skinto = CloneFighter.nameSkin[player.CF.shortcuts[player.CFshort]]
            if (CloneFighter.skinList[skinto] != nil) and CF_ReadySwitch(player, skinto) then
                player.CF.shifting = 1
                player.CF.shiftSkin = skinto
            else
                S_StartSoundAtVolume(nil, sfx_adderr, 127, player)
            end
        end
    end
    
    if player.CF.shifting then -- Shape Shift sequence!
        -- Give the player stasis for a bit...
        player.pflags = $|PF_FULLSTASIS
        player.powers[pw_flashing] = 1
        
        -- Sound and hoop
        if player.CF.shifting == 1 then
            S_StartSound(player.mo, sfx_clfsw)
        end
        
        local e
        if player.CF.shifting < 8 then -- Fade out
            e = player.CF.shifting*FRACUNIT/7
            player.mo.spriteyoffset = ease.inback(e, 0, -10*FRACUNIT, FRACUNIT)
            player.mo.spritexscale = ease.inback(e, FRACUNIT, FRACUNIT/15, FRACUNIT*15)
            player.mo.spriteyscale = ease.inback(e, FRACUNIT, 10*FRACUNIT, FRACUNIT)
            if player.followmobj then
                player.followmobj.spriteyoffset = ease.inback(e, 0, -10*FRACUNIT, FRACUNIT)
                player.followmobj.spritexscale = ease.inback(e, FRACUNIT, FRACUNIT/15, FRACUNIT*15)
                player.followmobj.spriteyscale = ease.inback(e, FRACUNIT, 10*FRACUNIT, FRACUNIT*2)
            end
            player.CFhoopheight = ease.outquad(e, -5*player.mo.scale, player.mo.height+(5*player.mo.scale))
            
        elseif player.CF.shifting > 8 then -- Fade in
            e = FRACUNIT-((player.CF.shifting-8)*FRACUNIT/8)
            player.mo.spriteyoffset = ease.inback(e, 0, -10*FRACUNIT, FRACUNIT)
            player.mo.spritexscale = ease.inback(e, FRACUNIT, FRACUNIT/15, FRACUNIT)
            player.mo.spriteyscale = ease.inback(e, FRACUNIT, 10*FRACUNIT, FRACUNIT)
            if player.followmobj then
                player.followmobj.spriteyoffset = ease.inback(e, 0, -10*FRACUNIT, FRACUNIT)
                player.followmobj.spritexscale = ease.inback(e, FRACUNIT, FRACUNIT/15, FRACUNIT*15)
                player.followmobj.spriteyscale = ease.inback(e, FRACUNIT, 10*FRACUNIT, FRACUNIT*2)
            end
            player.CFhoopheight = ease.outquad(e, -5*player.mo.scale, player.mo.height+(5*player.mo.scale))
            
        elseif player.CF.shifting == 8 then -- Switch!
            CF_ShiftSkin(player, CloneFighter.skinList[player.CF.shiftSkin])
            player.CFhoopheight = player.mo.height+(5*player.mo.scale)
        end
        
        -- Hoop
        if not (player.CFfronthoop and player.CFfronthoop.valid) then
            player.CFfronthoop = P_SpawnMobjFromMobj(player.mo, 0,0,player.CFhoopheight, MT_VWREF)
            player.CFbackhoop = P_SpawnMobjFromMobj(player.mo, 0,0,player.CFhoopheight, MT_VWREB)
            player.CFfronthoop.fuse, player.CFbackhoop.fuse = 17,17
        end
        P_MoveOrigin(player.CFfronthoop, player.mo.x,player.mo.y,player.mo.z+player.CFhoopheight)
        P_MoveOrigin(player.CFbackhoop, player.mo.x,player.mo.y,player.mo.z+player.CFhoopheight)
        
        -- Increase the timer.
        player.CF.shifting = $+1
        if (player.CF.shifting == 17) or not CF_ReadySwitchNS(player, player.CF.shiftSkin) then
            player.CF.shifting = 0 -- We're done! Or were interrupted daNG IT
            player.powers[pw_flashing] = TICRATE/2
            S_StopSoundByID(player.mo, sfx_clfsw)
            S_StartSound(player.mo, sfx_clfdn)
            player.mo.spriteyoffset, player.mo.spritexscale, player.mo.spriteyscale = 0, FRACUNIT, FRACUNIT
            if player.followmobj then
                player.followmobj.spriteyoffset, player.followmobj.spritexscale, player.followmobj.spriteyscale = 0, FRACUNIT, FRACUNIT
            end
        end
    end
    
    -- Visual things
    
    if player.CF.shifting and (player.CF.shifting != 3) and (player.CF.shifting != 15) then -- green when shapeshifting
        player.mo.color = SKINCOLOR_CFFADE
    elseif (player.dashmode >= 3*TICRATE) and (leveltime&2) then -- Boost Mode
        player.mo.color = skincolors[player.skincolor].invcolor
    elseif ((player.powers[pw_super] > 1) -- Super/Sol colors! Had to reverse-engineer SuperColors Revamped (sort of) for this
            or (player.mo.sprite2 == SPR2_TRNS) and (player.mo.frame&63 >= 4)) -- geez all this just to have a nice Super transform effect??
    or ((player.solchar) and (player.solchar.burningcolor) and (player.solchar.istransformed > 1)) then
        if player.scolor and (player.scolor != "default") then
            if player.scolor == "none" then
                player.mo.color = player.skincolor
            elseif player.scolorstring == "Advance" then
                player.mo.color = SKINCOLOR_SUPERADVANCEGOLD
            elseif player.scolorstring == "N_ Colour" then
                player.mo.color = R_GetColorByName(player.scolor)
            else
                player.mo.color = player.scolor + 2
            end
        else
            player.mo.color = SKINCOLOR_ABSOLUTE
        end
    else player.mo.color = player.skincolor end -- Back to default
    
    -- Reset these!!!
    player.CFsel, player.CFshort = 0,0
end)

addHook("ThinkFrame", do -- Transparent
    for player in players.iterate do
        if not player.mo then return end 
        if player.skin != #skins["clonefighter"] then
            if player.CF and (player.CF.active == true) then
                player.mo.color = player.skincolor
                player.mo.colorized = false
                player.mo.frame = $ & ~(FF_TRANS20|FF_FULLBRIGHT)
                if player.followmobj then
                    player.followmobj.colorized = false
                    player.followmobj.frame = $ & ~(FF_TRANS20|FF_FULLBRIGHT)
                end
                R_SetPlayerSkin(player, player.skin)
                player.CF.active = false
            end
        else
            player.mo.colorized = true
            player.mo.frame = $|FF_TRANS20|FF_FULLBRIGHT
            if player.followmobj then
                player.followmobj.colorized = true
                player.followmobj.frame = $|FF_TRANS20|FF_FULLBRIGHT
            end
        end
    end
end)